Index: uspace/lib/c/arch/amd64/include/libarch/types.h
===================================================================
--- uspace/lib/c/arch/amd64/include/libarch/types.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/amd64/include/libarch/types.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -48,6 +48,4 @@
 typedef int64_t native_t;
 
-typedef int64_t ssize_t;
-
 typedef uint64_t atomic_count_t;
 typedef int64_t atomic_signed_t;
Index: uspace/lib/c/arch/arm32/Makefile.common
===================================================================
--- uspace/lib/c/arch/arm32/Makefile.common	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/arm32/Makefile.common	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -28,8 +28,11 @@
 #
 
-GCC_CFLAGS += -ffixed-r9 -mtp=soft -fno-omit-frame-pointer -mapcs-frame -march=$(subst _,-,$(PROCESSOR_ARCH))
+COMMON_CFLAGS += -ffixed-r9 -mtp=soft -fno-omit-frame-pointer -mapcs-frame \
+	-march=$(subst _,-,$(PROCESSOR_ARCH))
+
+LFLAGS += --gc-sections
 
 ifeq ($(CONFIG_FPU),y)
-	GCC_CFLAGS += -mfloat-abi=hard
+	COMMON_CFLAGS += -mfloat-abi=hard
 else
 	BASE_LIBS += $(LIBSOFTFLOAT_PREFIX)/libsoftfloat.a
Index: uspace/lib/c/arch/arm32/include/libarch/elf_linux.h
===================================================================
--- uspace/lib/c/arch/arm32/include/libarch/elf_linux.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/arm32/include/libarch/elf_linux.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,5 +34,5 @@
 
 #ifndef LIBC_arm32_ELF_LINUX_H_
-#define LBIC_arm32_ELF_LINUX_H_
+#define LIBC_arm32_ELF_LINUX_H_
 
 #include <libarch/istate.h>
Index: uspace/lib/c/arch/arm32/include/libarch/faddr.h
===================================================================
--- uspace/lib/c/arch/arm32/include/libarch/faddr.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/arm32/include/libarch/faddr.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,5 +37,5 @@
 #define LIBC_arm32_FADDR_H_
 
-#include <libarch/types.h>
+#include <types/common.h>
 
 /** Calculate absolute address of function referenced by fptr pointer.
Index: uspace/lib/c/arch/arm32/include/libarch/fibril.h
===================================================================
--- uspace/lib/c/arch/arm32/include/libarch/fibril.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/arm32/include/libarch/fibril.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,5 +37,5 @@
 #define LIBC_arm32_FIBRIL_H_
 
-#include <libarch/types.h>
+#include <types/common.h>
 #include <align.h>
 #include <thread.h>
Index: uspace/lib/c/arch/arm32/include/libarch/inttypes.h
===================================================================
--- uspace/lib/c/arch/arm32/include/libarch/inttypes.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/arm32/include/libarch/inttypes.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,4 +34,8 @@
 #define LIBC_arm32_INTTYPES_H_
 
+#define PRIdPTR  PRId32  /**< Format for intptr_t. */
+#define PRIuPTR  PRIu32  /**< Format for uintptr_t. */
+#define PRIxPTR  PRIx32  /**< Format for hexadecimal uintptr_t. */
+
 #define PRIdn  PRId32  /**< Format for native_t. */
 #define PRIun  PRIu32  /**< Format for sysarg_t. */
Index: uspace/lib/c/arch/arm32/include/libarch/stddef.h
===================================================================
--- uspace/lib/c/arch/arm32/include/libarch/stddef.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/arm32/include/libarch/stddef.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,4 +39,5 @@
 
 typedef uint32_t size_t;
+typedef int32_t ssize_t;
 typedef int32_t ptrdiff_t;
 
Index: uspace/lib/c/arch/arm32/include/libarch/types.h
===================================================================
--- uspace/lib/c/arch/arm32/include/libarch/types.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/arm32/include/libarch/types.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -49,6 +49,4 @@
 typedef int32_t native_t;
 
-typedef int32_t ssize_t;
-
 typedef uint32_t atomic_count_t;
 typedef int32_t atomic_signed_t;
Index: uspace/lib/c/arch/ia32/Makefile.common
===================================================================
--- uspace/lib/c/arch/ia32/Makefile.common	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ia32/Makefile.common	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -28,10 +28,11 @@
 
 ifeq ($(PROCESSOR),i486)
-	GCC_CFLAGS += -march=i486 -mno-tls-direct-seg-refs -fno-omit-frame-pointer
+	COMMON_CFLAGS += -march=i486
 else
-	GCC_CFLAGS += -march=pentium -mno-tls-direct-seg-refs -fno-omit-frame-pointer
+	COMMON_CFLAGS += -march=pentium
 endif
 
-CLANG_CFLAGS += -fno-omit-frame-pointer
+COMMON_CFLAGS += -mno-tls-direct-seg-refs -fno-omit-frame-pointer
+LFLAGS += --gc-sections
 
 ENDIANESS = LE
Index: uspace/lib/c/arch/ia32/include/libarch/elf_linux.h
===================================================================
--- uspace/lib/c/arch/ia32/include/libarch/elf_linux.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ia32/include/libarch/elf_linux.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,5 +34,5 @@
 
 #ifndef LIBC_ia32_ELF_LINUX_H_
-#define LBIC_ia32_ELF_LINUX_H_
+#define LIBC_ia32_ELF_LINUX_H_
 
 #include <libarch/istate.h>
Index: uspace/lib/c/arch/ia32/include/libarch/faddr.h
===================================================================
--- uspace/lib/c/arch/ia32/include/libarch/faddr.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ia32/include/libarch/faddr.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define LIBC_ia32_FADDR_H_
 
-#include <libarch/types.h>
+#include <types/common.h>
 
 #define FADDR(fptr)  ((uintptr_t) (fptr))
Index: uspace/lib/c/arch/ia32/include/libarch/fibril.h
===================================================================
--- uspace/lib/c/arch/ia32/include/libarch/fibril.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ia32/include/libarch/fibril.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define LIBC_ia32_FIBRIL_H_
 
-#include <libarch/types.h>
+#include <types/common.h>
 #include <libarch/fibril_context.h>
 
Index: uspace/lib/c/arch/ia32/include/libarch/inttypes.h
===================================================================
--- uspace/lib/c/arch/ia32/include/libarch/inttypes.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ia32/include/libarch/inttypes.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,4 +34,8 @@
 #define LIBC_ia32_INTTYPES_H_
 
+#define PRIdPTR  PRId32  /**< Format for intptr_t. */
+#define PRIuPTR  PRIu32  /**< Format for uintptr_t. */
+#define PRIxPTR  PRIx32  /**< Format for hexadecimal uintptr_t. */
+
 #define PRIdn  PRId32  /**< Format for native_t. */
 #define PRIun  PRIu32  /**< Format for sysarg_t. */
Index: uspace/lib/c/arch/ia32/include/libarch/stddef.h
===================================================================
--- uspace/lib/c/arch/ia32/include/libarch/stddef.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ia32/include/libarch/stddef.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,4 +39,5 @@
 
 typedef uint32_t size_t;
+typedef int32_t ssize_t;
 typedef int32_t ptrdiff_t;
 
Index: uspace/lib/c/arch/ia32/include/libarch/syscall.h
===================================================================
--- uspace/lib/c/arch/ia32/include/libarch/syscall.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ia32/include/libarch/syscall.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,5 +38,5 @@
 
 #include <abi/syscall.h>
-#include <libarch/types.h>
+#include <types/common.h>
 
 #define __syscall0  __syscall_fast_func
Index: uspace/lib/c/arch/ia32/include/libarch/types.h
===================================================================
--- uspace/lib/c/arch/ia32/include/libarch/types.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ia32/include/libarch/types.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -48,7 +48,4 @@
 typedef int32_t native_t;
 
-typedef int32_t ssize_t;
-typedef uint32_t size_t;
-
 typedef uint32_t atomic_count_t;
 typedef int32_t atomic_signed_t;
Index: uspace/lib/c/arch/ia32/src/rtld/reloc.c
===================================================================
--- uspace/lib/c/arch/ia32/src/rtld/reloc.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ia32/src/rtld/reloc.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,4 +37,5 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include <inttypes.h>
 
 #include <libarch/rtld/elf_dyn.h>
@@ -79,5 +80,5 @@
 	str_tab = m->dyn.str_tab;
 
-	DPRINTF("address: 0x%x, entries: %d\n", (uintptr_t)rt, rt_entries);
+	DPRINTF("address: 0x%" PRIxPTR ", entries: %zd\n", (uintptr_t)rt, rt_entries);
 	
 	for (i = 0; i < rt_entries; ++i) {
Index: uspace/lib/c/arch/ia64/Makefile.common
===================================================================
--- uspace/lib/c/arch/ia64/Makefile.common	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ia64/Makefile.common	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -27,5 +27,5 @@
 #
 
-GCC_CFLAGS += -fno-unwind-tables
+COMMON_CFLAGS += -fno-unwind-tables
 
 ENDIANESS = LE
Index: uspace/lib/c/arch/ia64/include/libarch/elf_linux.h
===================================================================
--- uspace/lib/c/arch/ia64/include/libarch/elf_linux.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ia64/include/libarch/elf_linux.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,5 +34,5 @@
 
 #ifndef LIBC_ia64_ELF_LINUX_H_
-#define LBIC_ia64_ELF_LINUX_H_
+#define LIBC_ia64_ELF_LINUX_H_
 
 #include <libarch/istate.h>
Index: uspace/lib/c/arch/ia64/include/libarch/faddr.h
===================================================================
--- uspace/lib/c/arch/ia64/include/libarch/faddr.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ia64/include/libarch/faddr.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define LIBC_ia64_FADDR_H_
 
-#include <libarch/types.h>
+#include <types/common.h>
 
 /**
Index: uspace/lib/c/arch/ia64/include/libarch/fibril.h
===================================================================
--- uspace/lib/c/arch/ia64/include/libarch/fibril.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ia64/include/libarch/fibril.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,5 +39,5 @@
 #include <align.h>
 #include <libarch/stack.h>
-#include <libarch/types.h>
+#include <types/common.h>
 #include <libarch/fibril_context.h>
 
Index: uspace/lib/c/arch/ia64/include/libarch/inttypes.h
===================================================================
--- uspace/lib/c/arch/ia64/include/libarch/inttypes.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ia64/include/libarch/inttypes.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,4 +34,8 @@
 #define LIBC_ia64_INTTYPES_H_
 
+#define PRIdPTR  PRId64  /**< Format for intptr_t. */
+#define PRIuPTR  PRIu64  /**< Format for uintptr_t. */
+#define PRIxPTR  PRIx64  /**< Format for hexadecimal uintptr_t. */
+
 #define PRIdn  PRId64  /**< Format for native_t. */
 #define PRIun  PRIu64  /**< Format for sysarg_t. */
Index: uspace/lib/c/arch/ia64/include/libarch/stddef.h
===================================================================
--- uspace/lib/c/arch/ia64/include/libarch/stddef.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ia64/include/libarch/stddef.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,4 +39,5 @@
 
 typedef uint64_t size_t;
+typedef int64_t ssize_t;
 typedef int64_t ptrdiff_t;
 
Index: uspace/lib/c/arch/ia64/include/libarch/types.h
===================================================================
--- uspace/lib/c/arch/ia64/include/libarch/types.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ia64/include/libarch/types.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -48,6 +48,4 @@
 typedef int64_t native_t;
 
-typedef int64_t ssize_t;
-
 typedef uint64_t atomic_count_t;
 typedef int64_t atomic_signed_t;
Index: uspace/lib/c/arch/mips32/Makefile.common
===================================================================
--- uspace/lib/c/arch/mips32/Makefile.common	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/mips32/Makefile.common	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -27,7 +27,8 @@
 #
 
-GCC_CFLAGS += -msoft-float -mabi=32
+COMMON_CFLAGS += -msoft-float -mabi=32
 BASE_LIBS += $(LIBSOFTFLOAT_PREFIX)/libsoftfloat.a
 AS_PROLOG = .module softfloat;.abicalls;
+LFLAGS += --gc-sections
 
 ENDIANESS = LE
@@ -37,9 +38,9 @@
 
 ifeq ($(MACHINE),msim)
-	GCC_CFLAGS += -march=r4000 
+	COMMON_CFLAGS += -march=r4000
 endif
 
 ifeq ($(MACHINE),lmalta)
-	GCC_CFLAGS += -march=4kc
+	COMMON_CFLAGS += -march=4kc
 endif
 
Index: uspace/lib/c/arch/mips32/include/libarch/elf_linux.h
===================================================================
--- uspace/lib/c/arch/mips32/include/libarch/elf_linux.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/mips32/include/libarch/elf_linux.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,5 +34,5 @@
 
 #ifndef LIBC_mips32_ELF_LINUX_H_
-#define LBIC_mips32_ELF_LINUX_H_
+#define LIBC_mips32_ELF_LINUX_H_
 
 #include <libarch/istate.h>
Index: uspace/lib/c/arch/mips32/include/libarch/faddr.h
===================================================================
--- uspace/lib/c/arch/mips32/include/libarch/faddr.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/mips32/include/libarch/faddr.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define LIBC_mips32_FADDR_H_
 
-#include <libarch/types.h>
+#include <types/common.h>
 
 #define FADDR(fptr)  ((uintptr_t) (fptr))
Index: uspace/lib/c/arch/mips32/include/libarch/inttypes.h
===================================================================
--- uspace/lib/c/arch/mips32/include/libarch/inttypes.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/mips32/include/libarch/inttypes.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,4 +34,8 @@
 #define LIBC_mips32_INTTYPES_H_
 
+#define PRIdPTR  PRId32  /**< Format for intptr_t. */
+#define PRIuPTR  PRIu32  /**< Format for uintptr_t. */
+#define PRIxPTR  PRIx32  /**< Format for hexadecimal uintptr_t. */
+
 #define PRIdn  PRId32  /**< Format for native_t. */
 #define PRIun  PRIu32  /**< Format for sysarg_t. */
Index: uspace/lib/c/arch/mips32/include/libarch/stddef.h
===================================================================
--- uspace/lib/c/arch/mips32/include/libarch/stddef.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/mips32/include/libarch/stddef.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,4 +39,5 @@
 
 typedef uint32_t size_t;
+typedef int32_t ssize_t;
 typedef int32_t ptrdiff_t;
 
Index: uspace/lib/c/arch/mips32/include/libarch/types.h
===================================================================
--- uspace/lib/c/arch/mips32/include/libarch/types.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/mips32/include/libarch/types.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -49,6 +49,4 @@
 typedef int32_t native_t;
 
-typedef int32_t ssize_t;
-
 typedef uint32_t atomic_count_t;
 typedef int32_t atomic_signed_t;
Index: uspace/lib/c/arch/mips32eb/Makefile.common
===================================================================
--- uspace/lib/c/arch/mips32eb/Makefile.common	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/mips32eb/Makefile.common	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -27,7 +27,8 @@
 #
 
-GCC_CFLAGS += -msoft-float -mabi=32
+COMMON_CFLAGS += -msoft-float -mabi=32
 BASE_LIBS += $(LIBSOFTFLOAT_PREFIX)/libsoftfloat.a
 AS_PROLOG = .module softfloat;.abicalls;
+LFLAGS += --gc-sections
 
 ENDIANESS = BE
@@ -37,5 +38,5 @@
 
 ifeq ($(MACHINE),bmalta)
-	GCC_CFLAGS += -march=4kc
+	COMMON_CFLAGS += -march=4kc
 endif
 
Index: uspace/lib/c/arch/ppc32/Makefile.common
===================================================================
--- uspace/lib/c/arch/ppc32/Makefile.common	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ppc32/Makefile.common	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -27,14 +27,14 @@
 #
 
-
 ifeq ($(CONFIG_FPU),y)
-FLOATS=hard
+	FLOATS=hard
 else
-FLOATS=soft
+	FLOATS=soft
 endif
 
-GCC_CFLAGS += -mcpu=powerpc -m$(FLOATS)-float -m32
+COMMON_CFLAGS += -mcpu=powerpc -m$(FLOATS)-float -m32
 BASE_LIBS += $(LIBSOFTFLOAT_PREFIX)/libsoftfloat.a
 AFLAGS += -a32
+LFLAGS += --gc-sections
 
 ENDIANESS = BE
Index: uspace/lib/c/arch/ppc32/include/libarch/elf_linux.h
===================================================================
--- uspace/lib/c/arch/ppc32/include/libarch/elf_linux.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ppc32/include/libarch/elf_linux.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,5 +34,5 @@
 
 #ifndef LIBC_ppc32_ELF_LINUX_H_
-#define LBIC_ppc32_ELF_LINUX_H_
+#define LIBC_ppc32_ELF_LINUX_H_
 
 #include <libarch/istate.h>
Index: uspace/lib/c/arch/ppc32/include/libarch/faddr.h
===================================================================
--- uspace/lib/c/arch/ppc32/include/libarch/faddr.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ppc32/include/libarch/faddr.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define LIBC_ppc32_FADDR_H_
 
-#include <libarch/types.h>
+#include <types/common.h>
 
 #define FADDR(fptr)		((uintptr_t) (fptr))
Index: uspace/lib/c/arch/ppc32/include/libarch/inttypes.h
===================================================================
--- uspace/lib/c/arch/ppc32/include/libarch/inttypes.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ppc32/include/libarch/inttypes.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,4 +34,8 @@
 #define LIBC_ppc32_INTTYPES_H_
 
+#define PRIdPTR  PRId32  /**< Format for intptr_t. */
+#define PRIuPTR  PRIu32  /**< Format for uintptr_t. */
+#define PRIxPTR  PRIx32  /**< Format for hexadecimal uintptr_t. */
+
 #define PRIdn  PRId32  /**< Format for native_t. */
 #define PRIun  PRIu32  /**< Format for sysarg_t. */
Index: uspace/lib/c/arch/ppc32/include/libarch/stddef.h
===================================================================
--- uspace/lib/c/arch/ppc32/include/libarch/stddef.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ppc32/include/libarch/stddef.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,4 +39,5 @@
 
 typedef uint32_t size_t;
+typedef int32_t ssize_t;
 typedef int32_t ptrdiff_t;
 
Index: uspace/lib/c/arch/ppc32/include/libarch/types.h
===================================================================
--- uspace/lib/c/arch/ppc32/include/libarch/types.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/ppc32/include/libarch/types.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -48,6 +48,4 @@
 typedef int32_t native_t;
 
-typedef int32_t ssize_t;
-
 typedef uint32_t atomic_count_t;
 typedef int32_t atomic_signed_t;
Index: uspace/lib/c/arch/riscv64/Makefile.common
===================================================================
--- uspace/lib/c/arch/riscv64/Makefile.common	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/c/arch/riscv64/Makefile.common	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,34 @@
+#
+# Copyright (c) 2005 Martin Decky
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+BASE_LIBS += $(LIBSOFTFLOAT_PREFIX)/libsoftfloat.a
+
+ENDIANESS = LE
+
+BFD_NAME = elf64-littleriscv
+BFD_ARCH = riscv
Index: uspace/lib/c/arch/riscv64/include/libarch/config.h
===================================================================
--- uspace/lib/c/arch/riscv64/include/libarch/config.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/c/arch/riscv64/include/libarch/config.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,44 @@
+/*
+ * Copyright (c) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libcamd64
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_riscv64_CONFIG_H_
+#define LIBC_riscv64_CONFIG_H_
+
+#define PAGE_WIDTH  12
+#define PAGE_SIZE   (1 << PAGE_WIDTH)
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/arch/riscv64/include/libarch/elf_linux.h
===================================================================
--- uspace/lib/c/arch/riscv64/include/libarch/elf_linux.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/riscv64/include/libarch/elf_linux.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,5 +34,5 @@
 
 #ifndef LIBC_riscv64_ELF_LINUX_H_
-#define LBIC_riscv64_ELF_LINUX_H_
+#define LIBC_riscv64_ELF_LINUX_H_
 
 #include <libarch/istate.h>
Index: uspace/lib/c/arch/riscv64/include/libarch/faddr.h
===================================================================
--- uspace/lib/c/arch/riscv64/include/libarch/faddr.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/riscv64/include/libarch/faddr.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define LIBC_riscv64_FADDR_H_
 
-#include <libarch/types.h>
+#include <types/common.h>
 
 #define FADDR(fptr)  ((uintptr_t) (fptr))
Index: uspace/lib/c/arch/riscv64/include/libarch/inttypes.h
===================================================================
--- uspace/lib/c/arch/riscv64/include/libarch/inttypes.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/riscv64/include/libarch/inttypes.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,4 +34,8 @@
 #define LIBC_riscv64_INTTYPES_H_
 
+#define PRIdPTR  PRId64  /**< Format for intptr_t. */
+#define PRIuPTR  PRIu64  /**< Format for uintptr_t. */
+#define PRIxPTR  PRIx64  /**< Format for hexadecimal uintptr_t. */
+
 #define PRIdn  PRId64  /**< Format for native_t. */
 #define PRIun  PRIu64  /**< Format for sysarg_t. */
Index: uspace/lib/c/arch/riscv64/include/libarch/stddef.h
===================================================================
--- uspace/lib/c/arch/riscv64/include/libarch/stddef.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/riscv64/include/libarch/stddef.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,4 +39,5 @@
 
 typedef uint64_t size_t;
+typedef int64_t ssize_t;
 typedef int64_t ptrdiff_t;
 
Index: uspace/lib/c/arch/riscv64/include/libarch/syscall.h
===================================================================
--- uspace/lib/c/arch/riscv64/include/libarch/syscall.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/riscv64/include/libarch/syscall.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,5 +37,7 @@
 #define LIBC_riscv64_SYSCALL_H_
 
+#include <stdint.h>
 #include <abi/syscall.h>
+#include <types/common.h>
 
 #define __syscall0  __syscall
Index: uspace/lib/c/arch/riscv64/include/libarch/tls.h
===================================================================
--- uspace/lib/c/arch/riscv64/include/libarch/tls.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/riscv64/include/libarch/tls.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -51,5 +51,5 @@
 static inline tcb_t *__tcb_get(void)
 {
-	return NULL;
+	return (void *) 0;
 }
 
Index: uspace/lib/c/arch/riscv64/include/libarch/types.h
===================================================================
--- uspace/lib/c/arch/riscv64/include/libarch/types.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/riscv64/include/libarch/types.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -48,6 +48,4 @@
 typedef int64_t native_t;
 
-typedef int64_t ssize_t;
-
 typedef uint64_t atomic_count_t;
 typedef int64_t atomic_signed_t;
Index: uspace/lib/c/arch/riscv64/src/entry.c
===================================================================
--- uspace/lib/c/arch/riscv64/src/entry.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/riscv64/src/entry.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,5 +35,5 @@
 void __entry(void)
 {
-	__main(NULL);
+	__main((void *) 0);
 }
 
Index: uspace/lib/c/arch/riscv64/src/stacktrace.c
===================================================================
--- uspace/lib/c/arch/riscv64/src/stacktrace.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/riscv64/src/stacktrace.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -55,10 +55,10 @@
 uintptr_t stacktrace_fp_get(void)
 {
-	return (uintptr_t) NULL;
+	return 0;
 }
 
 uintptr_t stacktrace_pc_get(void)
 {
-	return (uintptr_t) NULL;
+	return 0;
 }
 
Index: uspace/lib/c/arch/riscv64/src/thread_entry.c
===================================================================
--- uspace/lib/c/arch/riscv64/src/thread_entry.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/riscv64/src/thread_entry.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -30,9 +30,10 @@
  */
 
+#include <types/common.h>
 #include "../../../generic/private/thread.h"
 
 void __thread_entry(void)
 {
-	__thread_main(NULL);
+	__thread_main((void *) 0);
 }
 
Index: uspace/lib/c/arch/sparc64/Makefile.common
===================================================================
--- uspace/lib/c/arch/sparc64/Makefile.common	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/sparc64/Makefile.common	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -28,12 +28,12 @@
 
 ifeq ($(PROCESSOR),sun4v)
-GCC_CFLAGS += -mcpu=niagara -mno-vis
+COMMON_CFLAGS += -mcpu=niagara -mno-vis
 else
-GCC_CFLAGS += -mcpu=ultrasparc
+COMMON_CFLAGS += -mcpu=ultrasparc
 endif
 
-GCC_CFLAGS += -m64 -mcmodel=medlow
+COMMON_CFLAGS += -m64 -mcmodel=medlow
 
-LFLAGS += -no-check-sections
+LFLAGS += -no-check-sections --gc-sections
 
 ENDIANESS = BE
Index: uspace/lib/c/arch/sparc64/include/libarch/elf_linux.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/elf_linux.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/sparc64/include/libarch/elf_linux.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,5 +34,5 @@
 
 #ifndef LIBC_sparc64_ELF_LINUX_H_
-#define LBIC_sparc64_ELF_LINUX_H_
+#define LIBC_sparc64_ELF_LINUX_H_
 
 #include <libarch/istate.h>
Index: uspace/lib/c/arch/sparc64/include/libarch/faddr.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/faddr.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/sparc64/include/libarch/faddr.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define LIBC_sparc64_FADDR_H_
 
-#include <libarch/types.h>
+#include <types/common.h>
 
 #define FADDR(fptr)		((uintptr_t) (fptr))
Index: uspace/lib/c/arch/sparc64/include/libarch/inttypes.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/inttypes.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/sparc64/include/libarch/inttypes.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,4 +34,8 @@
 #define LIBC_sparc64_INTTYPES_H_
 
+#define PRIdPTR  PRId64  /**< Format for intptr_t. */
+#define PRIuPTR  PRIu64  /**< Format for uintptr_t. */
+#define PRIxPTR  PRIx64  /**< Format for hexadecimal uintptr_t. */
+
 #define PRIdn  PRId64  /**< Format for native_t. */
 #define PRIun  PRIu64  /**< Format for sysarg_t. */
Index: uspace/lib/c/arch/sparc64/include/libarch/stddef.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/stddef.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/arch/sparc64/include/libarch/stddef.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,4 +39,5 @@
 
 typedef uint64_t size_t;
+typedef int64_t ssize_t;
 typedef int64_t ptrdiff_t;
 
